osgParticle::CompositePlacer Class Reference

`#include <CompositePlacer>`

Inheritance diagram for osgParticle::CompositePlacer:

## Public Member Functions

| CompositePlacer ()
| CompositePlacer (const CompositePlacer &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgParticle, CompositePlacer)
void | setPlacer (unsigned int i, Placer *p)
void | addPlacer (Placer *p)
| Add a child placer.
void | removePlacer (unsigned int i)
| Remove a child placer.
Placer * | getPlacer (unsigned int i)
| Get a child placer.
const Placer * | getPlacer (unsigned int i) const
unsigned int | getNumPlacers () const
| Get number of placers.
void | place (Particle *P) const
| Place a particle. Do not call it manually.
float | volume () const
| return the volume of the box
osg::Vec3 | getControlPosition () const
| return the control position
Public Member Functions inherited from osgParticle::Placer
| Placer ()
| Placer (const Placer &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual const char * | libraryName () const
virtual const char * | className () const
virtual bool | isSameKindAs (const osg::Object *obj) const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Types

typedef std::vector< osg::ref_ptr< Placer > > | PlacerList

## Protected Member Functions

virtual | ~CompositePlacer ()
CompositePlacer & | operator= (const CompositePlacer &)
Protected Member Functions inherited from osgParticle::Placer
| ~Placer ()
Placer & | operator= (const Placer &)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

PlacerList | _placers
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

A composite particle placer which allows particles to be generated from a union of placers.

## Member Typedef Documentation

## PlacerList

typedef std::vector< osg::ref_ptr<Placer> > osgParticle::CompositePlacer::PlacerList

protected

## Constructor & Destructor Documentation

## CompositePlacer() [1/2]

osgParticle::CompositePlacer::CompositePlacer | ( |  | ) |

inline

References osgParticle::Placer::Placer().

Referenced by CompositePlacer(), META_Object(), and operator=().

## CompositePlacer() [2/2]

osgParticle::CompositePlacer::CompositePlacer | ( | const CompositePlacer & | copy,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

inline

References _placers, CompositePlacer(), osgParticle::Placer::Placer(), and osg::CopyOp::SHALLOW_COPY.

## ~CompositePlacer()

virtual osgParticle::CompositePlacer::~CompositePlacer | ( |  | ) |

inline protected virtual

## Member Function Documentation

## addPlacer()

void osgParticle::CompositePlacer::addPlacer | ( | Placer * | p | ) |

inline

Add a child placer.

References _placers, and osgParticle::Placer::Placer().

Referenced by setPlacer().

## getControlPosition()

osg::Vec3 osgParticle::CompositePlacer::getControlPosition | ( |  | ) | const

inline virtual

return the control position

Implements osgParticle::Placer.

References _placers.

## getNumPlacers()

unsigned int osgParticle::CompositePlacer::getNumPlacers | ( |  | ) | const

inline

Get number of placers.

References _placers.

## getPlacer() [1/2]

Placer * osgParticle::CompositePlacer::getPlacer | ( | unsigned int | i | ) |

inline

Get a child placer.

References _placers, and osgParticle::Placer::Placer().

## getPlacer() [2/2]

const Placer * osgParticle::CompositePlacer::getPlacer | ( | unsigned int | i | ) | const

inline

References _placers, and osgParticle::Placer::Placer().

## META_Object()

osgParticle::CompositePlacer::META_Object | ( | osgParticle | ,
|  | CompositePlacer | )

References CompositePlacer().

## operator=()

CompositePlacer & osgParticle::CompositePlacer::operator= | ( | const CompositePlacer & |  | ) |

inline protected

References CompositePlacer().

## place()

void osgParticle::CompositePlacer::place | ( | Particle * | P | ) | const

inline virtual

Place a particle. Do not call it manually.

Implements osgParticle::Placer.

References _placers, osgParticle::range< ValueType >::get_random(), and volume().

## removePlacer()

void osgParticle::CompositePlacer::removePlacer | ( | unsigned int | i | ) |

inline

Remove a child placer.

References _placers.

## setPlacer()

void osgParticle::CompositePlacer::setPlacer | ( | unsigned int | i,
|  | Placer * | p )

inline

References _placers, addPlacer(), and osgParticle::Placer::Placer().

## volume()

float osgParticle::CompositePlacer::volume | ( |  | ) | const

inline virtual

return the volume of the box

Reimplemented from osgParticle::Placer.

References _placers.

Referenced by place().

## Member Data Documentation

## _placers

PlacerList osgParticle::CompositePlacer::_placers

protected

Referenced by addPlacer(), CompositePlacer(), getControlPosition(), getNumPlacers(), getPlacer(), getPlacer(), place(), removePlacer(), setPlacer(), and volume().

The documentation for this class was generated from the following file:

- CompositePlacer